#!/bin/bash
#
# updated by WIPAT 2554-08-02
#
#exit 0 = valid ; exit 1 = invalid

AUTHEN_SHADOW="YES"
AUTHEN_MAIL="YES"
DEFAULT_MAIL_SERVER="mail.psu.ac.th"
AUTHEN_LDAP="NO"
AUTHEN_SSH="NO"
SSH_SERVER="server.domain"
AUTHEN_PSU_PASSPORT="NO"

NAME=$(echo ${USER_NAME} | cut -d'"' -f2)
PASSWORD=$(echo ${USER_PASSWORD} | cut -d'"' -f 2-|sed "s/\"$//")
KEY="false"
MYKEY=""
if [ "${AUTHEN_SHADOW}" = "YES" ] ; then
  KEY=$(/bin/sh /etc/freeradius/check-shadow.sh "${NAME}" "${PASSWORD}")
  MYKEY=$(echo $KEY|grep -i -w "true")
  if [ -n "${MYKEY}" ] ; then
    exit 0
  fi
fi
if [ "${AUTHEN_LDAP}" = "YES" ] ; then
  KEY=$(/bin/sh /etc/freeradius/check-ldap.sh "${NAME}" "${PASSWORD}")
  MYKEY=$(echo $KEY|grep -i -w "true")
  if [ -n "${MYKEY}" ] ; then
    exit 0
  fi
fi
if [ "${AUTHEN_SSH}" = "YES" ] ; then
  KEY=$(/usr/bin/expect /etc/freeradius/check-ssh.exp ${SSH_SERVER} "${NAME}" "${PASSWORD}")
  MYKEY=$(echo $KEY|grep -i -w "true")
  if [ -n "${MYKEY}" ] ; then
    exit 0
  fi
fi
if [ "${AUTHEN_PSU_PASSPORT}" = "YES" ] ; then
  USER=$(echo ${NAME} | cut -d'@' -f1)
  KEY=$(/usr/bin/php /etc/freeradius/soap-authen.php ${USER} ${PASSWORD} $1 $2)
  MYKEY=$(echo ${KEY}|grep -i "true")
  if [ -n "${MYKEY}" ] ; then
    exit 0
  fi
fi
if [ "${AUTHEN_MAIL}" = "YES" ] ; then
  IS_EMAIL=$(echo ${NAME}|grep "@")
  if [ -n "${IS_EMAIL}" ] ; then
    USER=$(echo ${NAME} | cut -d'@' -f1)
    DOMAIN=$(echo ${NAME} | cut -d'@' -f2)
  else
    USER=${NAME}
    DOMAIN=${DEFAULT_MAIL_SERVER}
  fi
  case ${DOMAIN} in
  psu.ac.th) 
    HOST="mail.psu.ac.th" 
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-imap.exp" ;;
  eng.psu.ac.th) 
    HOST="mail.eng.psu.ac.th:995" 
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-pop3s-gmail.exp" ;;
  pharmacy.psu.ac.th) 
    HOST="mail.pharmacy.psu.ac.th" 
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-imap.exp" ;;
  pn.psu.ac.th) 
    HOST="bunga.pn.psu.ac.th" 
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-imap.exp" ;;
  gmail.com) 
    HOST="pop.gmail.com:995" 
    USER=${NAME}
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-pop3s-gmail.exp" ;;
  hotmail.com) 
    HOST="pop3.live.com:995" 
    USER=${NAME}
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-pop3s-hotmail.exp" ;;
  live.com) 
    HOST="pop3.live.com:995" 
    USER=${NAME}
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-pop3s-hotmail.exp" ;;
  yahoo.com) 
    HOST="pop.mail.yahoo.com:995" 
    USER=${NAME}
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-pop3s-gmail.exp" ;;
  *)
    HOST=${DOMAIN} 
    MYSCRIPT="/usr/bin/expect /etc/freeradius/check-pop3.exp" ;;
  esac
  KEY=$(${MYSCRIPT} ${HOST} "${USER}" "${PASSWORD}")
  MYKEY=$(echo $KEY|grep -i -w "true")
  if [ -n "${MYKEY}" ] ; then
    exit 0
  fi
fi
exit 1
#exit 0 = valid ; exit 1 = invalid
